
<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

    <title>Contributing to IMAPClient &#8212; IMAPClient 2.3.1 documentation</title>
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/sphinxdoc.css" />
    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
    <script src="_static/doctools.js"></script>
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Version 2.3.0" href="releases.html" />
    <link rel="prev" title="IMAPClient Class" href="api.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a></li>
        <li class="right" >
          <a href="releases.html" title="Version 2.3.0"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="api.html" title="IMAPClient Class"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">IMAPClient 2.3.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Contributing to IMAPClient</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="contributing-to-imapclient">
<h1>Contributing to IMAPClient<a class="headerlink" href="#contributing-to-imapclient" title="Permalink to this heading">¶</a></h1>
<p>The best way to contribute changes to IMAPClient is to fork the
official repository on Github, make changes in a branch in your
personal fork and then submit a pull request.</p>
<p>Discussion <a class="reference external" href="https://github.com/mjs/imapclient/discussions">on Github</a> before undertaking development is highly
encouraged for potentially major changes.</p>
<p>Although not essential, it will make the project maintainers much
happier if change submissions include appropriate updates to unit
tests, live tests and documentation. Please ask if you’re unsure how
of how the tests work.</p>
<p>Please read on if you plan on submitting changes to IMAPClient.</p>
<section id="source-code">
<h2>Source Code<a class="headerlink" href="#source-code" title="Permalink to this heading">¶</a></h2>
<p>The official source code repository for IMAPClient can be found on
Github at: <a class="reference external" href="https://github.com/mjs/imapclient">https://github.com/mjs/imapclient</a></p>
<p>Any major feature work will also be found as branches of this
repository.</p>
<section id="branches">
<h3>Branches<a class="headerlink" href="#branches" title="Permalink to this heading">¶</a></h3>
<p>Development for the next major release happens on the <code class="docutils literal notranslate"><span class="pre">master</span></code> branch.</p>
<p>There is also a branch for each major release series (for example:
<code class="docutils literal notranslate"><span class="pre">1.x</span></code>). When appropriate and when there will be future releases for
a series, changes may be selectively merged between <code class="docutils literal notranslate"><span class="pre">master</span></code> and a
stable release branch.</p>
</section>
<section id="release-tags">
<h3>Release Tags<a class="headerlink" href="#release-tags" title="Permalink to this heading">¶</a></h3>
<p>Each released version is available in the IMAPClient repository
as a Git tag (e.g. “0.9.1”).</p>
</section>
</section>
<section id="unit-tests">
<h2>Unit Tests<a class="headerlink" href="#unit-tests" title="Permalink to this heading">¶</a></h2>
<section id="running-unit-tests">
<h3>Running Unit Tests<a class="headerlink" href="#running-unit-tests" title="Permalink to this heading">¶</a></h3>
<p>To run the tests, from the root of the package source run:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python</span> <span class="o">-</span><span class="n">m</span> <span class="n">unittest</span> <span class="o">--</span><span class="n">verbose</span>
</pre></div>
</div>
</section>
<section id="testing-against-multiple-python-versions">
<h3>Testing Against Multiple Python Versions<a class="headerlink" href="#testing-against-multiple-python-versions" title="Permalink to this heading">¶</a></h3>
<p>When submitting a Pull Request to IMAPClient, tests are automatically run
against all the supported Python versions.</p>
<p>It is possible to run these tests locally using <a class="reference external" href="http://testrun.org/tox/">tox</a>. Once
installed, the <code class="docutils literal notranslate"><span class="pre">tox</span></code> command will use the tox.ini file in the root
of the project source and run the unit tests against the Python
versions officially supported by IMAPClient (provided these versions
of Python are installed!).</p>
<p>To avoid having to install all Python versions directly on a host, the
<code class="docutils literal notranslate"><span class="pre">tox-all</span></code> script can be used. It will run the unit tests inside a Docker
container which contains all supported Python versions. As long as Docker is
installed and your user account can sudo to root the following should work:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">./</span><span class="n">tox</span><span class="o">-</span><span class="nb">all</span>
</pre></div>
</div>
<p>The script passes any arguments on to tox. For example to run just the tests
just against Python 3.7 do:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="o">./</span><span class="n">tox</span><span class="o">-</span><span class="nb">all</span> <span class="o">-</span><span class="n">e</span> <span class="n">py37</span>
</pre></div>
</div>
</section>
<section id="writing-unit-tests">
<h3>Writing Unit Tests<a class="headerlink" href="#writing-unit-tests" title="Permalink to this heading">¶</a></h3>
<p>Protocol level unit tests should not act against a real IMAP server
but should use canned data instead. The IMAPClientTest base class
should typically be used as the base class for any tests - it provides
a mock IMAPClient instance at <cite>self.client</cite>. See the tests in
<cite>tests/test_imapclient.py</cite> for examples of how to write unit tests using
this approach.</p>
</section>
</section>
<section id="documentation">
<h2>Documentation<a class="headerlink" href="#documentation" title="Permalink to this heading">¶</a></h2>
<p>The source for the project’s documentation can be found under doc/src
in the source distribution.</p>
<p>In order to build the documentation you’ll need install
Sphinx. Running <code class="docutils literal notranslate"><span class="pre">pip</span> <span class="pre">install</span> <span class="pre">'.[doc]'</span></code> from the root of the project
source will do this.</p>
<p>Once Sphinx is installed, the documentation can be rebuilt using:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">python</span> <span class="n">setup</span><span class="o">.</span><span class="n">py</span> <span class="n">build_sphinx</span>
</pre></div>
</div>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <div>
    <h3><a href="index.html">Table of Contents</a></h3>
    <ul>
<li><a class="reference internal" href="#">Contributing to IMAPClient</a><ul>
<li><a class="reference internal" href="#source-code">Source Code</a><ul>
<li><a class="reference internal" href="#branches">Branches</a></li>
<li><a class="reference internal" href="#release-tags">Release Tags</a></li>
</ul>
</li>
<li><a class="reference internal" href="#unit-tests">Unit Tests</a><ul>
<li><a class="reference internal" href="#running-unit-tests">Running Unit Tests</a></li>
<li><a class="reference internal" href="#testing-against-multiple-python-versions">Testing Against Multiple Python Versions</a></li>
<li><a class="reference internal" href="#writing-unit-tests">Writing Unit Tests</a></li>
</ul>
</li>
<li><a class="reference internal" href="#documentation">Documentation</a></li>
</ul>
</li>
</ul>

  </div>
  <div>
    <h4>Previous topic</h4>
    <p class="topless"><a href="api.html"
                          title="previous chapter">IMAPClient Class</a></p>
  </div>
  <div>
    <h4>Next topic</h4>
    <p class="topless"><a href="releases.html"
                          title="next chapter">Version 2.3.0</a></p>
  </div>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/contributing.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a></li>
        <li class="right" >
          <a href="releases.html" title="Version 2.3.0"
             >next</a> |</li>
        <li class="right" >
          <a href="api.html" title="IMAPClient Class"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">IMAPClient 2.3.1 documentation</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Contributing to IMAPClient</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2014, Menno Smits.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 5.0.2.
    </div>
  </body>
</html>